<!--
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
 
      http://www.apache.org/licenses/LICENSE-2.0
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the 
  License.
-->
This page provides links to the per-release Trafodion documentation.

## Latest (In development)

Document                                              | Formats
------------------------------------------------------|-----------------------------------
Scalar UDFs in C                                      | [wiki](https://cwiki.apache.org/confluence/display/TRAFODION/Scalar+UDFs+-+In+C)
Trafodion Client Installation Guide                   | [Web Book](docs/client_install/index.html),     [PDF](docs/client_install/Trafodion_Client_Installation_Guide.pdf)
Trafodion Code Examples                               | [wiki](https://cwiki.apache.org/confluence/display/TRAFODION/Trafodion+Code+Examples)
Trafodion Command Interface Guide                     | [Web Book](docs/command_interface/index.html),  [PDF](docs/command_interface/Trafodion_Command_Interface_Guide.pdf)
Trafodion Control Query Default (CQD) Reference Guide | [Web Book](docs/cqd_reference/index.html),      [PDF](docs/cqd_interface/Trafodion_CQD_Reference_Guide.pdf)
Trafodion Database Connectivity Services Guide        | [Web Book](docs/dcs_reference/index.html),      [API](docs/dcs_reference/apidocs/index.html)
Trafodion JDBC Type 4 Programmer Reference Guide      | [Web Book](docs/jdbct4ref_guide/index.html),    [PDF](docs/jdbct4ref_guide/Trafodion_JDBCT4_Reference_Guide.pdf)
Trafodion Load and Transform Guide                    | [Web Book](docs/load_transform/index.html),     [PDF](docs/load_transform/Trafodion_Load_Transform_Guide.pdf)
Trafodion Messages Guide                              | [Web Book](docs/messages_guide/index.html),     [PDF](docs/messages_guide/Trafodion_Messages_Guide.pdf)
Trafodion Manageability                               | [wiki](https://cwiki.apache.org/confluence/display/TRAFODION/Trafodion+Manageability)
Trafodion odb User Guide                              | [Web Book](docs/odb/index.html),                [PDF](docs/odb/Trafodion_odb_User_Guide.pdf)
Trafodion Provisioning Guide                          | [Web Book](docs/provisioning_guide/index.html), [PDF](docs/provisioning_guide/Trafodion_Provisioning_Guide.pdf)
Trafodion REST Server Reference Guide                 | [Web Book](docs/rest_reference/index.html),     [API](docs/rest_reference/apidocs/index.html)
Trafodion SQL Reference Manual                        | [Web Book](docs/sql_reference/index.html),      [PDF](docs/sql_reference/Trafodion_SQL_Reference_Manual.pdf)
Trafodion Stored Procedures in Java (SPJ) Guide       | [Web Book](docs/spj_guide/index.html),          [PDF](docs/spj_guide/Trafodion_SPJ_Guide.pdf)
UDF Tutorial                                          | [wiki](https://cwiki.apache.org/confluence/display/TRAFODION/Tutorial%3A+The+object-oriented+UDF+interface)

## 2.1.0 Release

Document                                              | Formats
------------------------------------------------------|-----------------------------------
Scalar UDFs in C                                      | [wiki](https://cwiki.apache.org/confluence/display/TRAFODION/Scalar+UDFs+-+In+C)
Trafodion Client Installation Guide                   | [Web Book](docs/2.1.0/client_install/index.html),     [PDF](docs/2.1.0/client_install/Trafodion_Client_Installation_Guide.pdf)
Trafodion Code Examples                               | [wiki](https://cwiki.apache.org/confluence/display/TRAFODION/Trafodion+Code+Examples)
Trafodion Command Interface Guide                     | [Web Book](docs/2.1.0/command_interface/index.html),  [PDF](docs/2.1.0/command_interface/Trafodion_Command_Interface_Guide.pdf)
Trafodion Control Query Default (CQD) Reference Guide | [Web Book](docs/2.1.0/cqd_reference/index.html),      [PDF](docs/2.1.0/cqd_interface/Trafodion_CQD_Reference_Guide.pdf)
Trafodion Database Connectivity Services Guide        | [Web Book](docs/2.1.0/dcs_reference/index.html),      [API](docs/2.1.0/dcs_reference/apidocs/2.1.0/index.html)
Trafodion JDBC Type 4 Programmer Reference Guide      | [Web Book](docs/2.1.0/jdbct4ref_guide/index.html),    [PDF](docs/2.1.0/jdbct4ref_guide/Trafodion_JDBCT4_Reference_Guide.pdf)
Trafodion Load and Transform Guide                    | [Web Book](docs/2.1.0/load_transform/index.html),     [PDF](docs/2.1.0/load_transform/Trafodion_Load_Transform_Guide.pdf)
Trafodion Messages Guide                              | [Web Book](docs/2.1.0/messages_guide/index.html),     [PDF](docs/2.1.0/messages_guide/Trafodion_Messages_Guide.pdf)
Trafodion Manageability                               | [wiki](https://cwiki.apache.org/confluence/display/TRAFODION/Trafodion+Manageability)
Trafodion odb User Guide                              | [Web Book](docs/2.1.0/odb/index.html),                [PDF](docs/2.1.0/odb/Trafodion_odb_User_Guide.pdf)
Trafodion Provisioning Guide                          | [Web Book](docs/2.1.0/provisioning_guide/index.html), [PDF](docs/2.1.0/provisioning_guide/Trafodion_Provisioning_Guide.pdf)
Trafodion REST Server Reference Guide                 | [Web Book](docs/2.1.0/rest_reference/index.html),     [API](docs/2.1.0/rest_reference/apidocs/2.1.0/index.html)
Trafodion SQL Reference Manual                        | [Web Book](docs/2.1.0/sql_reference/index.html),      [PDF](docs/2.1.0/sql_reference/Trafodion_SQL_Reference_Manual.pdf)
Trafodion Stored Procedures in Java (SPJ) Guide       | [Web Book](docs/2.1.0/spj_guide/index.html),          [PDF](docs/2.1.0/spj_guide/Trafodion_SPJ_Guide.pdf)
UDF Tutorial                                          | [wiki](https://cwiki.apache.org/confluence/display/TRAFODION/Tutorial%3A+The+object-oriented+UDF+interface)

## 2.0.x Releases

Document                                              | Formats
------------------------------------------------------|-----------------------------------
Trafodion Client Installation Guide                   | [Web Book](docs/2.0.0/client_install/index.html),     [PDF](docs/2.0.0/client_install/Trafodion_Client_Installation_Guide.pdf)
Trafodion Command Interface Guide                     | [Web Book](docs/2.0.0/command_interface/index.html),  [PDF](docs/2.0.0/command_interface/Trafodion_Command_Interface_Guide.pdf)
Trafodion Control Query Default (CQD) Reference Guide | [Web Book](docs/2.0.0/cqd_reference/index.html),      [PDF](docs/2.0.0/cqd_interface/Trafodion_CQD_Reference_Guide.pdf)
Trafodion Database Connectivity Services Guide        | [Web Book](docs/2.0.0/dcs_reference/index.html),      [API](docs/2.0.0/dcs_reference/apidocs/index.html)
Trafodion JDBC Type 4 Programmer Reference Guide      | [Web Book](docs/2.0.0/jdbct4ref_guide/index.html),    [PDF](docs/2.0.0/jdbct4ref_guide/Trafodion_JDBCT4_Reference_Guide.pdf)
Trafodion Load and Transform Guide                    | [Web Book](docs/2.0.0/load_transform/index.html),     [PDF](docs/2.0.0/load_transform/Trafodion_Load_Transform_Guide.pdf)
Trafodion Messages Guide                              | [Web Book](docs/2.0.0/messages_guide/index.html),     [PDF](docs/2.0.0/messages_guide/Trafodion_Messages_Guide.pdf)
Trafodion odb User Guide                              | [Web Book](docs/2.0.0/odb/index.html),                [PDF](docs/2.0.0/odb/Trafodion_odb_User_Guide.pdf)
Trafodion Provisioning Guide                          | [Web Book](docs/2.0.0/provisioning_guide/index.html), [PDF](docs/2.0.0/provisioning_guide/Trafodion_Provisioning_Guide.pdf)
Trafodion REST Server Reference Guide                 | [Web Book](docs/2.0.0/rest_reference/index.html),     [API](docs/2.0.0/rest_reference/apidocs/index.html)
Trafodion SQL Reference Manual                        | [Web Book](docs/2.0.0/sql_reference/index.html),      [PDF](docs/2.0.0/sql_reference/Trafodion_SQL_Reference_Manual.pdf)
Trafodion Stored Procedures in Java (SPJ) Guide       | [Web Book](docs/2.0.0/spj_guide/index.html),          [PDF](docs/2.0.0/spj_guide/Trafodion_SPJ_Guide.pdf)

## 1.3.0 Release

Document                                              | Formats
------------------------------------------------------|-----------------------------------
Trafodion Client Installation Guide                   | [Web Book](docs/1.3.0/client_install/index.html),     [PDF](docs/1.3.0/client_install/Trafodion_Client_Installation_Guide.pdf)
Trafodion Command Interface Guide                     | [Web Book](docs/1.3.0/command_interface/index.html),  [PDF](docs/1.3.0/command_interface/Trafodion_Command_Interface_Guide.pdf)
Trafodion Control Query Default (CQD) Reference Guide | [Web Book](docs/1.3.0/cqd_reference/index.html),      [PDF](docs/1.3.0/cqd_interface/Trafodion_CQD_Reference_Guide.pdf)
Trafodion Database Connectivity Services Guide        | [Web Book](docs/1.3.0/dcs_reference/index.html),      [API](docs/1.3.0/dcs_reference/apidocs/index.html)
Trafodion Load and Transform Guide                    | [Web Book](docs/1.3.0/load_transform/index.html),     [PDF](docs/1.3.0/load_transform/Trafodion_Load_Transform_Guide.pdf)
Trafodion Messages Guide                              | [Web Book](docs/1.3.0/messages_guide/index.html),     [PDF](docs/1.3.0/messages_guide/Trafodion_Messages_Guide.pdf)
Trafodion odb User Guide                              | [Web Book](docs/1.3.0/odb/index.html),                [PDF](docs/1.3.0/odb/Trafodion_odb_User_Guide.pdf)
Trafodion Provisioning Guide                          | [Web Book](docs/1.3.0/provisioning_guide/index.html), [PDF](docs/1.3.0/provisioning_guide/Trafodion_Provisioning_Guide.pdf)
Trafodion REST Server Reference Guide                 | [Web Book](docs/1.3.0/rest_reference/index.html),     [API](docs/1.3.0/rest_reference/apidocs/index.html)
Trafodion SQL Reference Manual                        | [Web Book](docs/1.3.0/sql_reference/index.html),      [PDF](docs/1.3.0/sql_reference/Trafodion_SQL_Reference_Manual.pdf)
Trafodion Stored Procedures in Java (SPJ) Guide       | [Web Book](docs/1.3.0/spj_guide/index.html),          [PDF](docs/1.3.0/spj_guide/Trafodion_SPJ_Guide.pdf)

